---
{# jinja2 template for creating vms creation task #}
- name: 'group.local.tasks'
  block:

  # hci: try to get server facts
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.try.server.facts'
    vmware_guest_facts:
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      name: '{{ server_fqdn }}'
    register: vmsFactsCheck
    changed_when: False
    failed_when: False


  # hci: create servers (if not exists only)
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.create.server.from.template'
    vmware_guest:
      state: 'present'
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms location
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      cluster:    '{{ SERVER_PROPERTIES.vms_cluster }}'
      folder:     '{{ SERVER_PROPERTIES.vms_folder }}'
      template:   '{{ SERVER_PROPERTIES.image }}'
      # vms settings
      name: '{{ server_fqdn }}'
      # vms hardware
      hardware:
        memory_mb: {{ SERVER_PROPERTIES.vram_gib|int * 1024 }}
        num_cpus:  {{ SERVER_PROPERTIES.vcpu_num|int }}
      # vms volumes
      disk:
        # system volume
        - size_gb: {{ SERVER_PROPERTIES.vhdd_gib|int }}
          type: thin
          datastore: '{{ SERVER_PROPERTIES.vms_datastore }}'
      # vms networks
      networks:
{% for THIS_NETWORK in vms_networks %}
        - name: '{{ THIS_NETWORK.name }}'
{% if THIS_NETWORK.mode in ["static"] %}
          ip:           '{{ THIS_NETWORK.ip }}'
          netmask:      '{{ THIS_NETWORK.nm }}'
          gateway:      '{{ THIS_NETWORK.gw }}'
          domain:       '{{ SERVER_PROPERTIES.domain }}'
          dns_servers:  {{ SERVER_PROPERTIES.nameservers }}
{% endif %}
{% if THIS_NETWORK.mode in ["static","dhcp"] %}
          type: '{{ THIS_NETWORK.mode }}'
{% endif %}
{% endfor %}
      # os customization
      customization:
        hostname:     '{{ SERVER_PROPERTIES.name }}'
        domain:       '{{ SERVER_PROPERTIES.domain }}'
        dns_servers:  {{ SERVER_PROPERTIES.nameservers }}
        password:     '{{ vms_default_pass }}'
    register: vmsCreated
    # only if server does not exists yet
    when:
      - (vmsFactsCheck.instance is not defined)

  - name: '{{ role_namespace }}.debug.vmsCreated'
    debug: var=vmsCreated
    when: ("show_debugs" in run_opts)


  # hci: enable networks
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.enable.networks'
    vmware_guest:
      state: 'present'
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      cluster:    '{{ SERVER_PROPERTIES.vms_cluster }}'
      name: '{{ server_fqdn }}'
      # vms networks
      networks:
{% for THIS_NETWORK in vms_networks %}
        - name: '{{ THIS_NETWORK.name }}'
          start_connected: true
{% if THIS_NETWORK.mode in ["static"] %}
          ip:           '{{ THIS_NETWORK.ip }}'
          netmask:      '{{ THIS_NETWORK.nm }}'
          gateway:      '{{ THIS_NETWORK.gw }}'
          domain:       '{{ SERVER_PROPERTIES.domain }}'
          dns_servers:  {{ SERVER_PROPERTIES.nameservers }}
{% endif %}
{% if THIS_NETWORK.mode in ["static","dhcp"] %}
          type: '{{ THIS_NETWORK.mode }}'
{% endif %}
{% endfor %}
    # only after first creation
    when:
      - (vmsCreated.instance is defined)
      - (vmsCreated.instance.hw_power_status not in ["poweredOn"])


  # hci: update server hardware if needed
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.config.hardware'
    vmware_guest:
      state: 'present'
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      cluster:    '{{ SERVER_PROPERTIES.vms_cluster }}'
      name: '{{ server_fqdn }}'
      # vms hardware
      hardware:
        memory_mb: {{ SERVER_PROPERTIES.vram_gib|int * 1024 }}
        num_cpus:  {{ SERVER_PROPERTIES.vcpu_num|int }}
    register: vmsConfig

  - name: '{{ role_namespace }}.debug.vmsConfig'
    debug: var=vmsConfig
    when: ("show_debugs" in run_opts)


  # hci: deploy data volumes
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.manage.data.volumes'
    vmware_guest_disk:
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      name: '{{ server_fqdn }}'
      disk:
        # system volume
        - state:      'present'
          datastore:  '{{ SERVER_PROPERTIES.vms_datastore }}'
          size_gb:    {{ SERVER_PROPERTIES.vhdd_gib|int }}
          type: thin
          scsi_type: 'paravirtual'
          scsi_controller: 0
          unit_number: 0
{% if vms_volumes|count > 0 %}
        # data volumes
{% for DATA_VOLUME in vms_volumes %}
        - state:      '{{ DATA_VOLUME.state|default("present") }}'
          datastore:  '{{ SERVER_PROPERTIES.vms_datastore }}'
          size_gb:    {{ DATA_VOLUME.vol_sizegb|int }}
          type: thin
          scsi_type: 'paravirtual'
          scsi_controller: 1
          unit_number: {{ loop.index }}
{% endfor %}
    register: vmsDisks

  - name: '{{ role_namespace }}.debug.vmsDisks'
    debug: var=vmsDisks
    when: ("show_debugs" in run_opts)
{% endif %}


  # hci: initial poweron
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.initial.poweron'
    vmware_guest:
      state: 'poweredon'
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      cluster:    '{{ SERVER_PROPERTIES.vms_cluster }}'
      name: '{{ server_fqdn }}'
    register: vmsPoweron
    # wait for running status
    until: (vmsPoweron.instance.guest_tools_status == "guestToolsRunning")
    retries: 12
    delay: 10


  # hci: initial reboot to apply customizations
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.initial.reboot'
    vmware_guest:
      state: 'rebootguest'
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      cluster:    '{{ SERVER_PROPERTIES.vms_cluster }}'
      name: '{{ server_fqdn }}'
    # only after first creation
    when:
      - (vmsCreated.instance is defined)
      - (vmsCreated.instance.hw_power_status not in ["poweredOn"])

  # wait for reboot to occur
  - name: '{{ role_namespace }}.wait.for.reboot'
    pause:
      seconds: 30
      prompt: 'Waiting for server to perform reboot'
    # only after first creation
    when:
      - (vmsCreated.instance is defined)
      - (vmsCreated.instance.hw_power_status not in ["poweredOn"])

  # hci: wait for vm to be back
  - name: '{{ role_namespace }}.wait.for.boot'
    vmware_guest:
      state: 'poweredon'
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      cluster:    '{{ SERVER_PROPERTIES.vms_cluster }}'
      name: '{{ server_fqdn }}'
    register: vmsBoot
    # wait for running status
    until: (vmsBoot.instance.guest_tools_status == "guestToolsRunning")
    retries: 12
    delay: 10
    # only after first creation
    when:
      - (vmsCreated.instance is defined)
      - (vmsCreated.instance.hw_power_status not in ["poweredOn"])


  # hci: get final facts
  # ----------------------------------------------------------------------------
  - name: '{{ role_namespace }}.get.server.facts'
    vmware_guest_facts:
      # vcenter settings
      hostname: '{{ vcenter_host }}'
      username: '{{ vcenter_user }}'
      password: '{{ vcenter_pass }}'
      validate_certs: no
      # vms selector
      datacenter: '{{ SERVER_PROPERTIES.vms_datacenter }}'
      name: '{{ server_fqdn }}'
    register: vmsFacts

# block settings
  delegate_to: localhost


# eof
